#define byt char

#ifndef __GRID_EYE__
#define __GRID_EYE__

#include <Arduino.h>

#define GridEye_DeviceAddress_0 (0x68)
#define GridEye_DeviceAddress_1 (0x69)

#define GridEye_PixelOut_Unit (0.25)
#define GridEye_ThermistorTemp_Unit (0.0625)

#define GridEye_ConvertPixelOutToCelsius(t) ((t)*GridEye_PixelOut_Unit)
#define GridEye_ConvertThermistorTempToCelsius(t) ((t)*GridEye_ThermistorTemp_Unit)

class GridEye {
public:
	GridEye(byt devadr = GridEye_DeviceAddress_0);
	~GridEye();
	void sleep(void);
	void wakeUp(void);
	void standBy60(void);
	void standBy10(void);
	void flagReset(void);
	void initialReset(void);
	void setFramerate(byt framerate);
	void serMovingAverageEnable(byt flag);
	void setInterruptLevel(int hiLvl, int loLvl, int hysLvl = 0, byt absoluteMode = 0, byt intrOutEnable = 0);
	byt status(void);
	int thermistorTemp(void);
	void pixelInterrupt(byt *intrBuf);
	void pixelOut(int *pixelBuf);
	void pixelOutRaw(byt *rawBuf);
private:
	byt devadr_;
	void regw(byt adr, byt data);
	void regw(byt adr, byt *data, byt siz);
	byt regr(byt adr, byt *buff, byt siz);
};

#endif
